Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.sql
Interface Connection

public interface Connection

A connection (session) with a specific database. Within the context of a Connection, SQL statements are executed and results are returned.

A Connection's database is able to provide information describing its tables, its supported SQL grammar, its stored procedures, the capabilities of this connection, and so on. This information is obtained with the `getMetaData` method.

Note: By default the Connection automatically commits changes after executing each statement. If auto commit has been disabled, the method `commit` must be called explicitly; otherwise, database changes will not be saved.

See Also:
  `DriverManager.getConnection(java.lang.String, java.util.Properties)`, `Statement`, `ResultSet`, `

  Methods that are new in the JDBC 2.0 API are tagged @since 1.2.

  `

Field Summary
`static int` | `TRANSACTION_NONE` Indicates that transactions are not supported.
`static int` | `TRANSACTION_READ_COMMITTED` Dirty reads are prevented; non-repeatable reads and phantom reads can occur.
`static int` | `TRANSACTION_READ_UNCOMMITTED` Dirty reads, non-repeatable reads and phantom reads can occur.
`static int` | `TRANSACTION_REPEATABLE_READ` Dirty reads and non-repeatable reads are prevented; phantom reads can occur.
`static int` | `TRANSACTION_SERIALIZABLE` Dirty reads, non-repeatable reads and phantom reads are prevented.

Method Summary
`void` | `clearWarnings()` Clears all warnings reported for this `Connection` object.
`void` | `close()` Releases a Connection's database and JDBC resources immediately instead of waiting for them to be automatically released.
`void` | `commit()` Makes all changes made since the previous commit/rollback permanent and releases any database locks currently held by the Connection.
`Statement` | `createStatement()` Creates a `Statement` object for sending SQL statements to the database.
`Statement` | `createStatement(int resultSetType, int resultSetConcurrency)` Creates a `Statement` object that will generate `ResultSet` objects with the given type and concurrency.
`boolean` | `getAutoCommit()` Gets the current auto-commit state.
`String` | `getCatalog()` Returns the Connection's current catalog name.
`DatabaseMetaData` | `getMetaData()` Gets the metadata regarding this connection's database.
`int` | `getTransactionIsolation()` Gets this Connection's current transaction isolation level.
`Map` | `getTypeMap()` Gets the type map object associated with this connection.
`SQLWarning` | `getWarnings()` Returns the first warning reported by calls on this Connection.
`boolean` | `isClosed()` Tests to see if a Connection is closed.
`boolean` | `isReadOnly()` Tests to see if the connection is in read-only mode.
`String` | `nativeSQL(String sql)` Converts the given SQL statement into the system's native SQL grammar.
`CallableStatement` | `prepareCall(String sql)` Creates a `CallableStatement` object for calling database stored procedures.
`CallableStatement` | `prepareCall(String sql, int resultSetType, int resultSetConcurrency)` Creates a `CallableStatement` object that will generate `ResultSet` objects with the given type and concurrency.
`PreparedStatement` | `prepareStatement(String sql)` Creates a `PreparedStatement` object for sending parameterized SQL statements to the database.
`PreparedStatement` | `prepareStatement(String sql, int resultSetType, int resultSetConcurrency)` Creates a `PreparedStatement` object that will generate `ResultSet` objects with the given type and concurrency.
`void` | `rollback()` Drops all changes made since the previous commit/rollback and releases any database locks currently held by this Connection.
`void` | `setAutoCommit(boolean autoCommit)` Sets this connection's auto-commit mode.
`void` | `setCatalog(String catalog)` Sets a catalog name in order to select a subspace of this Connection's database in which to work.
`void` | `setReadOnly(boolean readOnly)` Puts this connection in read-only mode as a hint to enable database optimizations.
`void` | `setTransactionIsolation(int level)` Attempts to change the transaction isolation level to the one given.
`void` | `setTypeMap(Map map)` Installs the given type map as the type map for this connection.

Field Detail

### TRANSACTION_NONE

    public static final int TRANSACTION_NONE

  Indicates that transactions are not supported.

### TRANSACTION_READ_UNCOMMITTED

    public static final int TRANSACTION_READ_UNCOMMITTED

  Dirty reads, non-repeatable reads and phantom reads can occur. This level allows a row changed by one transaction to be read by another transaction before any changes in that row have been committed (a "dirty read"). If any of the changes are rolled back, the second transaction will have retrieved an invalid row.

### TRANSACTION_READ_COMMITTED

    public static final int TRANSACTION_READ_COMMITTED

  Dirty reads are prevented; non-repeatable reads and phantom reads can occur. This level only prohibits a transaction from reading a row with uncommitted changes in it.

### TRANSACTION_REPEATABLE_READ

    public static final int TRANSACTION_REPEATABLE_READ

  Dirty reads and non-repeatable reads are prevented; phantom reads can occur. This level prohibits a transaction from reading a row with uncommitted changes in it, and it also prohibits the situation where one transaction reads a row, a second transaction alters the row, and the first transaction rereads the row, getting different values the second time (a "non-repeatable read").

### TRANSACTION_SERIALIZABLE

    public static final int TRANSACTION_SERIALIZABLE

  Dirty reads, non-repeatable reads and phantom reads are prevented. This level includes the prohibitions in TRANSACTION_REPEATABLE_READ and further prohibits the situation where one transaction reads all rows that satisfy a WHERE condition, a second transaction inserts a row that satisfies that WHERE condition, and the first transaction rereads for the same condition, retrieving the additional "phantom" row in the second read.

Method Detail

### createStatement

    public Statement createStatement()
                              throws SQLException

  Creates a `Statement` object for sending SQL statements to the database. SQL statements without parameters are normally executed using Statement objects. If the same SQL statement is executed many times, it is more efficient to use a `PreparedStatement` object.

  Result sets created using the returned `Statement` object will by default have forward-only type and read-only concurrency.

  Returns:
    a new Statement object
  Throws:
    `SQLException` - if a database access error occurs

### prepareStatement

    public PreparedStatement prepareStatement(String sql)
                                       throws SQLException

  Creates a `PreparedStatement` object for sending parameterized SQL statements to the database. A SQL statement with or without IN parameters can be pre-compiled and stored in a PreparedStatement object. This object can then be used to efficiently execute this statement multiple times.

  Note: This method is optimized for handling parametric SQL statements that benefit from precompilation. If the driver supports precompilation, the method `prepareStatement` will send the statement to the database for precompilation. Some drivers may not support precompilation. In this case, the statement may not be sent to the database until the `PreparedStatement` is executed. This has no direct effect on users; however, it does affect which method throws certain SQLExceptions. Result sets created using the returned PreparedStatement will have forward-only type and read-only concurrency, by default.

  Parameters:
    `sql` - a SQL statement that may contain one or more '?' IN parameter placeholders
  Returns:
    a new PreparedStatement object containing the pre-compiled statement
  Throws:
    `SQLException` - if a database access error occurs

### prepareCall

    public CallableStatement prepareCall(String sql)
                                  throws SQLException

  Creates a `CallableStatement` object for calling database stored procedures. The `CallableStatement` object provides methods for setting up its IN and OUT parameters, and methods for executing the call to a stored procedure.

  Note: This method is optimized for handling stored procedure call statements. Some drivers may send the call statement to the database when the method `prepareCall` is done; others may wait until the `CallableStatement` object is executed. This has no direct effect on users; however, it does affect which method throws certain SQLExceptions. Result sets created using the returned CallableStatement will have forward-only type and read-only concurrency, by default.

  Parameters:
    `sql` - a SQL statement that may contain one or more '?' parameter placeholders. Typically this statement is a JDBC function call escape string.
  Returns:
    a new CallableStatement object containing the pre-compiled SQL statement
  Throws:
    `SQLException` - if a database access error occurs

### nativeSQL

    public String nativeSQL(String sql)
                     throws SQLException

  Converts the given SQL statement into the system's native SQL grammar. A driver may convert the JDBC sql grammar into its system's native SQL grammar prior to sending it; this method returns the native form of the statement that the driver would have sent.
  Parameters:
    `sql` - a SQL statement that may contain one or more '?' parameter placeholders
  Returns:
    the native form of this statement
  Throws:
    `SQLException` - if a database access error occurs

### setAutoCommit

    public void setAutoCommit(boolean autoCommit)
                       throws SQLException

  Sets this connection's auto-commit mode. If a connection is in auto-commit mode, then all its SQL statements will be executed and committed as individual transactions. Otherwise, its SQL statements are grouped into transactions that are terminated by a call to either the method `commit` or the method `rollback`. By default, new connections are in auto-commit mode. The commit occurs when the statement completes or the next execute occurs, whichever comes first. In the case of statements returning a ResultSet, the statement completes when the last row of the ResultSet has been retrieved or the ResultSet has been closed. In advanced cases, a single statement may return multiple results as well as output parameter values. In these cases the commit occurs when all results and output parameter values have been retrieved.
  Parameters:
    `autoCommit` - true enables auto-commit; false disables auto-commit.
  Throws:
    `SQLException` - if a database access error occurs

### getAutoCommit

    public boolean getAutoCommit()
                          throws SQLException

  Gets the current auto-commit state.
  Returns:
    the current state of auto-commit mode
  Throws:
    `SQLException` - if a database access error occurs
  See Also:
    `setAutoCommit(boolean)`

### commit

    public void commit()
                throws SQLException

  Makes all changes made since the previous commit/rollback permanent and releases any database locks currently held by the Connection. This method should be used only when auto-commit mode has been disabled.
  Throws:
    `SQLException` - if a database access error occurs
  See Also:
    `setAutoCommit(boolean)`

### rollback

    public void rollback()
                  throws SQLException

  Drops all changes made since the previous commit/rollback and releases any database locks currently held by this Connection. This method should be used only when auto- commit has been disabled.
  Throws:
    `SQLException` - if a database access error occurs
  See Also:
    `setAutoCommit(boolean)`

### close

    public void close()
               throws SQLException

  Releases a Connection's database and JDBC resources immediately instead of waiting for them to be automatically released.

  Note: A Connection is automatically closed when it is garbage collected. Certain fatal errors also result in a closed Connection.

  Throws:
    `SQLException` - if a database access error occurs

### isClosed

    public boolean isClosed()
                     throws SQLException

  Tests to see if a Connection is closed.
  Returns:
    true if the connection is closed; false if it's still open
  Throws:
    `SQLException` - if a database access error occurs

### getMetaData

    public DatabaseMetaData getMetaData()
                                 throws SQLException

  Gets the metadata regarding this connection's database. A Connection's database is able to provide information describing its tables, its supported SQL grammar, its stored procedures, the capabilities of this connection, and so on. This information is made available through a DatabaseMetaData object.
  Returns:
    a DatabaseMetaData object for this Connection
  Throws:
    `SQLException` - if a database access error occurs

### setReadOnly

    public void setReadOnly(boolean readOnly)
                     throws SQLException

  Puts this connection in read-only mode as a hint to enable database optimizations.

  Note: This method cannot be called while in the middle of a transaction.

  Parameters:
    `readOnly` - true enables read-only mode; false disables read-only mode.
  Throws:
    `SQLException` - if a database access error occurs

### isReadOnly

    public boolean isReadOnly()
                       throws SQLException

  Tests to see if the connection is in read-only mode.
  Returns:
    true if connection is read-only and false otherwise
  Throws:
    `SQLException` - if a database access error occurs

### setCatalog

    public void setCatalog(String catalog)
                    throws SQLException

  Sets a catalog name in order to select a subspace of this Connection's database in which to work. If the driver does not support catalogs, it will silently ignore this request.
  Throws:
    `SQLException` - if a database access error occurs

### getCatalog

    public String getCatalog()
                      throws SQLException

  Returns the Connection's current catalog name.
  Returns:
    the current catalog name or null
  Throws:
    `SQLException` - if a database access error occurs

### setTransactionIsolation

    public void setTransactionIsolation(int level)
                                 throws SQLException

  Attempts to change the transaction isolation level to the one given. The constants defined in the interface `Connection` are the possible transaction isolation levels.

  Note: This method cannot be called while in the middle of a transaction.

  Parameters:
    `level` - one of the TRANSACTION_* isolation values with the exception of TRANSACTION_NONE; some databases may not support other values
  Throws:
    `SQLException` - if a database access error occurs
  See Also:
    `DatabaseMetaData.supportsTransactionIsolationLevel(int)`

### getTransactionIsolation

    public int getTransactionIsolation()
                                throws SQLException

  Gets this Connection's current transaction isolation level.
  Returns:
    the current TRANSACTION_* mode value
  Throws:
    `SQLException` - if a database access error occurs

### getWarnings

    public SQLWarning getWarnings()
                           throws SQLException

  Returns the first warning reported by calls on this Connection.

  Note: Subsequent warnings will be chained to this SQLWarning.

  Returns:
    the first SQLWarning or null
  Throws:
    `SQLException` - if a database access error occurs

### clearWarnings

    public void clearWarnings()
                       throws SQLException

  Clears all warnings reported for this `Connection` object. After a call to this method, the method `getWarnings` returns null until a new warning is reported for this Connection.
  Throws:
    `SQLException` - if a database access error occurs

### createStatement

    public Statement createStatement(int resultSetType,
                                     int resultSetConcurrency)
                              throws SQLException

  Creates a `Statement` object that will generate `ResultSet` objects with the given type and concurrency. This method is the same as the `createStatement` method above, but it allows the default result set type and result set concurrency type to be overridden.
  Parameters:
    `resultSetType` - a result set type; see ResultSet.TYPE_XXX
    `resultSetConcurrency` - a concurrency type; see ResultSet.CONCUR_XXX
  Returns:
    a new Statement object
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    1.2
  See Also:
    What Is in the JDBC 2.0 API

### prepareStatement

    public PreparedStatement prepareStatement(String sql,
                                              int resultSetType,
                                              int resultSetConcurrency)
                                       throws SQLException

  Creates a `PreparedStatement` object that will generate `ResultSet` objects with the given type and concurrency. This method is the same as the `prepareStatement` method above, but it allows the default result set type and result set concurrency type to be overridden.
  Parameters:
    `resultSetType` - a result set type; see ResultSet.TYPE_XXX
    `resultSetConcurrency` - a concurrency type; see ResultSet.CONCUR_XXX
  Returns:
    a new PreparedStatement object containing the pre-compiled SQL statement
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    1.2
  See Also:
    What Is in the JDBC 2.0 API

### prepareCall

    public CallableStatement prepareCall(String sql,
                                         int resultSetType,
                                         int resultSetConcurrency)
                                  throws SQLException

  Creates a `CallableStatement` object that will generate `ResultSet` objects with the given type and concurrency. This method is the same as the `prepareCall` method above, but it allows the default result set type and result set concurrency type to be overridden.
  Parameters:
    `resultSetType` - a result set type; see ResultSet.TYPE_XXX
    `resultSetConcurrency` - a concurrency type; see ResultSet.CONCUR_XXX
  Returns:
    a new CallableStatement object containing the pre-compiled SQL statement
  Throws:
    `SQLException` - if a database access error occurs
  Since:
    1.2
  See Also:
    What Is in the JDBC 2.0 API

### getTypeMap

    public Map getTypeMap()
                   throws SQLException

  Gets the type map object associated with this connection. Unless the application has added an entry to the type map, the map returned will be empty.
  Returns:
    the `java.util.Map` object associated with this `Connection` object
  Since:
    1.2
  See Also:
    What Is in the JDBC 2.0 API

### setTypeMap

    public void setTypeMap(Map map)
                    throws SQLException

  Installs the given type map as the type map for this connection. The type map will be used for the custom mapping of SQL structured types and distinct types.
  Parameters:
    `the` - `java.util.Map` object to install as the replacement for this `Connection` object's default type map
  Since:
    1.2
  See Also:
    What Is in the JDBC 2.0 API

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2001 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.